/* This file is part of guile-with-graphics, a graphic library for Guile

Copyright (C) 2010  Luca Saiu

This file was not distributed at the beginning so that it wasn't
completely trivial to understand how blobs are formed (it was still
easy for a good programmer); now that the course is over I can publish
everything.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#if !(defined(_GNU_SOURCE))
#define _GNU_SOURCE
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <string.h>
#include "../src/proprietary.h"

/* I want this file to be simple and self-contained.  I could have
   written it in a cleanear way, but I don't care in this case. */
int main(void){
  int i;
  /* Go on until the stream is over.  We need i to be an int because
     the result of getc() may be EOF, which is not guaranteed to fit
     in a char. */
  while((i = getc(stdin)) != EOF){
    char c = (char)i;
    /* Destructively frobnicate the single character, and echo it: */
    frob(&c, 1, /* nothing */, /* nothing */, /* nothing */);
    putc(c, stdout);
  } // while
  
  return EXIT_SUCCESS;
}
