;;; This file is part of guile-with-graphics, a graphic library for Guile

;;; Copyright (C) 2009  Luca Saiu

;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(use-modules (ice-9 threads))
(use-modules (ice-9 format))
(use-modules (ice-9 rdelim))
(use-modules (srfi srfi-9))

(define (make-client-to-server-port server-host-name server-port)
  (let ((socket (socket PF_INET SOCK_STREAM 0))
        (host-name->address (lambda (host-name)
                              (car (array-ref (gethostbyname host-name) 4)))))
    (connect socket AF_INET (host-name->address server-host-name) server-port)
    socket))

(define (make-server-socket server-port)
  (let ((server-socket (socket PF_INET SOCK_STREAM 0)))
    (setsockopt server-socket SOL_SOCKET SO_REUSEADDR 1)
    (bind server-socket AF_INET INADDR_ANY server-port)
    (listen server-socket 5)
    server-socket))

(define (accept-connection-from-client server-socket)
  (let* ((port-and-address (accept server-socket))
         (port-to-client (car port-and-address)))
    port-to-client))
